<?php
/*
* Plugin Name: Coupon Pro
* Plugin URI: http://progostech.com/
* Description: Makes it easy for merchants to create, send & manage coupons. Generate coupons in bulk and send them to customers. Import / Export coupons using CSV file. Show Coupons on product, cart and my account page. 
* Author: 20script
* Author URI: http://www.20script.ir/
* Text Domain: COUPON_PRO_TXT_DMN
* Version: 1.0.5
* Requires at least: 4.3
*/
// Exit if accessed directly 
if ( ! defined( 'ABSPATH' ) ) { 
	exit; 
} 
if (!defined('WC_COUPON_PRO_DIR'))
    define('WC_COUPON_PRO_DIR', plugin_dir_path(__FILE__));
if (!defined('WC_COUPON_PRO_URL'))
    define('WC_COUPON_PRO_URL', plugin_dir_url(__FILE__));

if(!class_exists('SCP_Smart_Coupons_Pro')){
	class SCP_Smart_Coupons_Pro{
		public function __construct(){
			$active_plugins=apply_filters( 'active_plugins', get_option( 'active_plugins', array()));
			if(is_multisite()) 
		  	$active_plugins =array_merge($active_plugins, array_keys( get_site_option( 'active_sitewide_plugins', array())));
			// Check if WooCommerce not active
			if ( !in_array( 'woocommerce/woocommerce.php', $active_plugins)){
				add_action('admin_notices',  array($this, 'progos_wc_coupon_pro_admin_notices'));
			}else{
				$this->init();
			}
		}
		public function progos_wc_coupon_pro_admin_notices(){
	    	global $pagenow;
	    	if($pagenow==='plugins.php'){
		    	$class = 'notice notice-error is-dismissible';
	            $message = __('Coupon Pro needs Woocommerce to be installed and active.', 'COUPON_PRO_TXT_DMN');
	            printf('<div class="%1$s"><p>%2$s</p></div>', $class, $message);
	        }
	    }
	    public function init(){
			// Enqueues all Scripts and Styles
			add_action( 'admin_enqueue_scripts', array($this,'progos_smart_coupons_enqueue_scripts_backend' ));
			/**        
		    * Load language.     
		    */
		    if ( function_exists( 'load_plugin_textdomain' ) ){
				load_plugin_textdomain('COUPON_PRO_TXT_DMN', false, dirname(plugin_basename(__FILE__)) . '/language/');
			}
			if(is_admin()){
				//Includes Admin Setting Class file
				require_once WC_COUPON_PRO_DIR.'includes/class-coupon-pro-settings-helper.php';
				//Includes Admin Setting Class file
				require_once WC_COUPON_PRO_DIR.'includes/class-coupon-pro-settings.php';
				//Includes  Generate Bulk Coupons
				require_once WC_COUPON_PRO_DIR.'includes/class-coupon-pro-generate-bulk-coupons.php';
				//Includes Send Coupons to User
				require_once WC_COUPON_PRO_DIR.'includes/class-coupon-pro-send-by-email.php';
				//Includes Import Smart Coupons from CSV file
				require_once WC_COUPON_PRO_DIR.'includes/class-coupon-pro-import.php';
			}
				//Includes Show coupons on front page
				require_once WC_COUPON_PRO_DIR.'includes/coupon-pro-frontend-func.php';
		}
		function progos_smart_coupons_enqueue_scripts_backend() {
				wp_enqueue_style( 'coupon-pro-style', WC_COUPON_PRO_URL.'css/style.css', '');
		}
	}
	new SCP_Smart_Coupons_Pro();
}