<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
if ( ! class_exists( 'Coupon_Pro_Import_Export_Coupons' ) ) {
	class Coupon_Pro_Import_Export_Coupons {
		public function __construct() {
			add_action( 'admin_menu', array( $this, 'coupon_pro_import_menu') );
			add_action( 'admin_init', array( $this, 'coupon_pro_import_data_action' ) );			
		}
		public function coupon_pro_import_menu() {
			add_submenu_page(
							'woocommerce',
							__('Import Smart Coupon','COUPON_PRO_TXT_DMN'),
							__('Import Smart Coupon','COUPON_PRO_TXT_DMN'),
							'edit_pages', 'import_coupon_pro',
							array($this , 'func_import_coupon_pro' )
							);
		}
		public function func_import_coupon_pro() {
			$action = add_query_arg( array( 'page' => 'import_coupon_pro', 'action' => 'import_data_from_csv' ), 'admin.php' );			
			?>
			<h2>
				<?php echo __( 'Coupons Pro', 'COUPON_PRO_TXT_DMN' ); ?>
				<a href="<?php echo trailingslashit( admin_url() ) . 'post-new.php?post_type=shop_coupon'; ?>" class="page-title-action"><?php echo __( 'Add Coupon', 'COUPON_PRO_TXT_DMN' ); ?></a>
			</h2>
			<?php 
			Coupon_Pro_Settings_Helper::tabs();
			?>
			<p class="description"><?php echo _e( 'Import Coupons from CSV file', 'COUPON_PRO_TXT_DMN' ); ?></p>			
			<?php if ( ! empty( $_GET['import'] ) && $_GET['import'] == 'yes' ) {
				echo '<div id="message" class="updated fade"><p><strong>' . __( 'CSV file import successfully.', 'COUPON_PRO_TXT_DMN' ) . '</strong></p></div>';
			} ?>
			<div class="coupons_import_coupons">
				<form name="import-sc" id="import-sc" action="<?php echo esc_attr( wp_nonce_url( $action, 'import-upload' ) ); ?>" method="post" enctype="multipart/form-data">
					<label><strong><?php echo __( 'Select a CSV file', 'COUPON_PRO_TXT_DMN' ); ?></strong><small> (<?php printf( __( 'Maximum file size: %s', 'COUPON_PRO_TXT_DMN' ), '2M' ); ?>)</small></label><br><br>
					<input type="file" name="import" id="upload" size="25" required  accept=".csv"/>
					<input type="hidden" name="action" value="save" />
					<input type="hidden" name="max_file_size" value="2M" />
					<br><br><br><br>
					<input type="submit" value="<?php esc_attr_e( 'Import CSV file', 'COUPON_PRO_TXT_DMN' ); ?>" />
				</form>
			</div>
			<p class="description"><?php echo _e( 'Please download CSV file to add your data into it and Import it', 'COUPON_PRO_TXT_DMN' ); ?></p>			
			<p class="description"><a href="<?php echo esc_url(WC_COUPON_PRO_URL.'data/sample_sc.csv'); ?>"><?php echo _e( 'Click here to download sample file', 'COUPON_PRO_TXT_DMN' ); ?></a></p>
			<?php
		}
		public function func_export_coupon_pro(){
			$action = add_query_arg( array( 'page' => 'import_coupon_pro', 'action' => 'import_data_from_csv' ), 'admin.php' );			
			?>
			<h2>
				<?php echo __( 'Coupons Pro', 'COUPON_PRO_TXT_DMN' ); ?>
				<a href="<?php echo trailingslashit( admin_url() ) . 'post-new.php?post_type=shop_coupon'; ?>" class="page-title-action"><?php echo __( 'Add Coupon', 'COUPON_PRO_TXT_DMN' ); ?></a>
			</h2>
			<?php 
				Coupon_Pro_Settings_Helper::tabs();
			?>
			<p class="description"><?php echo _e( 'Export Coupons in a CSV file', 'COUPON_PRO_TXT_DMN' ); ?></p>			
			<?php if ( ! empty( $_GET['export'] ) && $_GET['export'] == 'yes' ) {
				echo '<div id="message" class="updated fade"><p><strong>' . __( 'CSV file exported successfully.', 'COUPON_PRO_TXT_DMN' ) . '</strong></p></div>';
			} ?>
			<div class="coupons_import_coupons">
				<form name="export-sc" id="export-sc" action="" method="post">
					<br><br>
					<input type="submit" value="<?php esc_attr_e( 'Export CSV file', 'COUPON_PRO_TXT_DMN' ); ?>" />
				</form>
			</div>
			<?php
		}
		public function coupon_pro_import_data_action() {
			if ( ! empty( $_GET['action'] ) && ( $_GET['action'] == 'import_data_from_csv' ) && ! empty( $_GET['page'] ) && ( $_GET['page'] == 'import_coupon_pro' ) ) {
			 	$fileName = $_FILES["import"]["tmp_name"];				
				$parsed_data = $this->parse_csv_file( $fileName );
				if(isset($parsed_data[0]) && !empty($parsed_data[0])){
					foreach ($parsed_data[0] as $key => $value) {
						$this->import_coupon( $value );
					}
				}
				$page_url = admin_url( 'admin.php?page=import_coupon_pro&import=yes' );
				wp_safe_redirect( $page_url );
			}
		}
		public static function import_coupon( $post ) {
			$csv_coupon_id = ''; 
			$coupon_code  = wc_format_coupon_code( $post['post_title'] );
			$id_from_code = wc_get_coupon_id_by_code( $coupon_code );
			if ( $id_from_code ) {
				WC_Admin_Meta_Boxes::add_error( __( 'Coupon code already exists - customers will use the latest coupon with this code.', 'COUPON_PRO_TXT_DMN' ) );
			}
			
			$postdata = array(
				'post_author'    => get_current_user_id(),
				'post_title'     => strtolower( trim($post['post_title']) ),
				'post_name'      => strtolower( trim($post['post_title']) ),
				'post_status'    => "publish", 
				'post_type'      => 'shop_coupon',
			);
			$post_id = wp_insert_post( $postdata);
			if (!is_wp_error( $post_id)){
				
				if(isset($post['discount_type']) && !empty($post['discount_type'])){
					$all_discount_types = wc_get_coupon_types();
					$discount_type = '';
					if ( array_key_exists( $post['discount_type'], $all_discount_types ) ) {
						$discount_type = $post['discount_type'];//array_search( $meta_value, $all_discount_types );
					}else {
						$discount_type = 'percent';
					}
					update_post_meta( $post_id, 'discount_type', $discount_type);
				}

				if(isset($post['coupon_amount']) && !empty($post['coupon_amount']))
					update_post_meta( $post_id, 'coupon_amount', wc_clean($post['coupon_amount']));

				if(isset($post['minimum_amount']) && !empty($post['minimum_amount']))
					update_post_meta( $post_id, 'minimum_amount', wc_clean($post['minimum_amount']));

				if(isset($post['maximum_amount']) && !empty($post['maximum_amount']))
					update_post_meta( $post_id, 'maximum_amount', wc_clean($post['maximum_amount']));

				if(isset($post['product_ids']) && !empty($post['product_ids']))
					update_post_meta( $post_id, 'product_ids', wc_clean($post['product_ids']));

				if(isset($post['expiry_date']) && !empty($post['expiry_date'])){
					$expiry_date = date('Y-m-d', strtotime(wc_clean($post['expiry_date'])));
					update_post_meta( $post_id,'expiry_date', $expiry_date); }

				if(isset($post['wcs_number_payments']) && !empty($post['wcs_number_payments']))
					update_post_meta( $post_id, '_wcs_number_payments', wc_clean($post['wcs_number_payments']));

				if(isset($post['exclude_product_ids']) && !empty($post['exclude_product_ids']))
					update_post_meta( $post_id, 'exclude_product_ids', wc_clean($post['exclude_product_ids']));

				if(isset($post['product_categories']) && !empty($post['product_categories']))
					update_post_meta( $post_id, 'product_categories', wc_clean($post['product_categories']));

				if(isset($post['exclude_product_categories']) && !empty($post['exclude_product_categories']))
					update_post_meta( $post_id, 'exclude_product_categories', wc_clean($post['exclude_product_categories']));

				if(isset($post['customer_email']) && !empty($post['customer_email']) && is_email($post['customer_email']))
					update_post_meta( $post_id, 'customer_email', wc_clean($post['customer_email']));

				if(isset($post['exclude_sale_items']) && !empty($post['exclude_sale_items']))
					update_post_meta( $post_id, 'exclude_sale_items', wc_clean($post['exclude_sale_items']));

				if(isset($post['individual_use']) && !empty($post['individual_use']))
					update_post_meta( $post_id, 'individual_use', wc_clean($post['individual_use']));

				if(isset($post['limit_usage_to_x_item']) && !empty($post['limit_usage_to_x_item']))
					update_post_meta( $post_id, 'limit_usage_to_x_item', wc_clean($post['limit_usage_to_x_item']));

				if(isset($post['smart_coupon_visible_on_my_account']) && !empty($post['smart_coupon_visible_on_my_account']))
					update_post_meta( $post_id, 'smart_coupon_visible_on_my_account', wc_clean($post['smart_coupon_visible_on_my_account']));

				if(isset($post['smart_coupon_visible_on_cart']) && !empty($post['smart_coupon_visible_on_cart']))
					update_post_meta( $post_id, 'smart_coupon_visible_on_cart', wc_clean($post['smart_coupon_visible_on_cart']));

				if(isset($post['free_shipping']) && !empty($post['free_shipping']))
					update_post_meta( $post_id, 'free_shipping', wc_clean($post['free_shipping']));

				if(isset($post['usage_limit']) && !empty($post['usage_limit']))
					update_post_meta( $post_id, 'usage_limit', wc_clean($post['usage_limit']));

				if(isset($post['usage_limit_per_user']) && !empty($post['usage_limit_per_user']))
					update_post_meta( $post_id, 'usage_limit_per_user', wc_clean($post['usage_limit_per_user']));

				return $post_id;
			}
		}
		public function parse_csv_file( $filepath ) {
			$parsed_data = array();
			if ( ( $handle = fopen( $filepath, 'r' ) ) !== false ) {
				$header = fgetcsv( $handle, 0 );
				while ( ( $postmeta = fgetcsv( $handle, 0 ) ) !== false ) {
					$row = array();
					foreach ( $header as $key => $heading ) {
						$f_heading = strtolower( $heading );
						$row[ $f_heading ] = ( isset( $postmeta[ $key ] ) ) ? utf8_encode( stripslashes( $postmeta[ $key ] )) : '';
						$raw_headers[ $f_heading ] = $heading;
					}
					$parsed_data[] = $row;
					unset( $postmeta, $row );
				}
				fclose( $handle );
			}
			return array( $parsed_data, $raw_headers );
		}
	}	
}
new Coupon_Pro_Import_Export_Coupons();