<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
if ( ! class_exists( 'Coupon_Pro_Send_Email' ) ) {
	class Coupon_Pro_Send_Email {
		public function __construct() {
			add_filter( 'views_edit-shop_coupon', array( $this, 'smart_coupons_views_row' ) );
			add_action( 'admin_menu', array( $this, 'coupon_pro_by_menu_id') );
			add_action( 'admin_init', array( $this, 'coupon_pro_send_init' ) );
			add_action( 'admin_head', array( $this, 'woocommerce_coupon_admin_head' ) );
		}
		public function smart_coupons_views_row( $views = null ) {
			global $typenow;
			if ( $typenow == 'shop_coupon' ) {
				Coupon_Pro_Settings_Helper::tabs();
			}
			return $views;
		}
		public function woocommerce_coupon_admin_head() {
			remove_submenu_page( 'woocommerce', 'coupon_pro_email_coupons' );
			remove_submenu_page( 'woocommerce', 'coupon_pro_generate_bulk' );
			remove_submenu_page( 'woocommerce', 'import_coupon_pro' );
			remove_submenu_page( 'woocommerce', 'coupon_pro_setting' );
			remove_submenu_page( 'woocommerce', 'shop_coupon' );
		}
		function coupon_pro_by_menu_id() {
			add_submenu_page(
								'woocommerce',
								__('Send Coupon Credit','COUPON_PRO_TXT_DMN'),
								__('Send Coupon Credit','COUPON_PRO_TXT_DMN'),
								'edit_pages', 'coupon_pro_email_coupons',
								array($this , 'func_coupon_pro_email_coupons' )
							);
		}
		function func_coupon_pro_email_coupons() {
			$get_symbol = get_woocommerce_currency_symbol();
			$settings = array( 
				'media_buttons' => false,
				'textarea_rows' => 10,
			);
			?>
			<h2>
				<?php echo __( 'Coupons Pro', 'COUPON_PRO_TXT_DMN' ); ?>
				<a href="<?php echo trailingslashit( admin_url() ) . 'post-new.php?post_type=shop_coupon'; ?>" class="page-title-action"><?php echo __( 'Add Coupon', 'COUPON_PRO_TXT_DMN' ); ?></a>
			</h2>
			<?php 
				Coupon_Pro_Settings_Helper::tabs();
			?>
			<p class="description"><?php _e( 'Email coupon to one or more people', 'COUPON_PRO_TXT_DMN' ); ?></p>
			<div class="coupons_send_email">
				<?php if ( ! empty( $_GET['sent'] ) && $_GET['sent'] == 'valid' ) {
					echo '<div id="message" class="updated fade"><p><strong>' . __( 'Coupon Credit sent successfully.', 'COUPON_PRO_TXT_DMN' ) . '</strong></p></div>';
				}?>
				<form action="/wp-admin/admin.php?page=coupon_pro_email_coupons&amp;action=sent_wp_coupon" method="post">
					<table class="form-table">
						<tbody>
							<tr>
								<td>
									<label for="coupon_pro_email"><strong><?php _e( 'Send to', 'COUPON_PRO_TXT_DMN' ); ?> *</strong></label>
									<input type="text" name="coupon_pro_email" id="coupon_pro_email" required="" style="width: 100%;" placeholder="mail@example.com">
									<?php
										if ( ! empty( $_GET['email'] ) && $_GET['email'] == 'invalid' ) {
											echo '<div class="error fade"><strong>' . __( 'Invalid email address.', 'COUPON_PRO_TXT_DMN' ) . '</strong></div>';
										}
									?>
									<i>For multiple email addresses use comma ","</i>
								</td>
							</tr>
							<tr>
								<td>
									<label for="coupon_pro_amount"><strong><?php _e( 'Select Coupon', 'COUPON_PRO_TXT_DMN' ); ?> *</strong></label>
									<br/>
									<select name="price_type">  
										<option value="fixed_cart"><?php echo $get_symbol; ?></option>
										<option value="percent ">Percentage</option>
									</select>
									<input type="number" required name="coupon_pro_amount" id="amount" class="input-text" style="width: 80px;">
									OR
									<?php echo $this->get_woocommerce_coupons(); ?>
									<br />
									<?php
									if ( ! empty( $_GET['coupon_amount'] ) && $_GET['coupon_amount'] == 'invalid' ) {
										echo '<div id="message" class="error fade"><p><strong>' . __( 'Invalid amount.', 'COUPON_PRO_TXT_DMN' ) . '</strong></p></div>';
									}
									?> 
									<?php
										if ( ! empty( $_GET['coupon_id'] ) && $_GET['coupon_id'] == 'invalid' ) {
											echo '<div id="message" class="error fade"><p><strong>' . __( 'Invalid coupon.', 'COUPON_PRO_TXT_DMN' ) . '</strong></p></div>';
										}
									?>
								</td>
							</tr>
							<tr>
								<td>
									<label for="coupon_pro_message"><strong><?php _e( 'Message', 'COUPON_PRO_TXT_DMN' ); ?></strong><small>(<?php _e( 'optional', 'COUPON_PRO_TXT_DMN' ); ?>)</small></label>
									<?php wp_editor( '', 'coupon_pro_message', $settings); ?>
								</td>
							</tr>
						</tbody>
					</table>
					<p class="submit">
						<input type="submit" name="submit" id="submit" class="button button-primary" value="<?php _e( 'Send Message', 'COUPON_PRO_TXT_DMN' ); ?>">
					</p>
					<script type="text/javascript">
						jQuery(function ($) {
						    var inputs = $('input[name=coupon_pro_amount],select[name=send_coupons_id]');
						    inputs.on('input', function () {
						        // Set the required property of the other input to false if this input is not empty.
						        inputs.not(this).prop('required', !$(this).val().length);
						    });
						});
					</script>
				</form>
			</div>
			<?php
		}
		function get_woocommerce_coupons(){
			global  $woocommerce;
			$get_symbol =  get_woocommerce_currency_symbol();
			$args = array(
			    'posts_per_page'   => -1,
			    'orderby'          => 'title',
			    'order'            => 'asc',
			    'post_type'        => 'shop_coupon',
			    'post_status'      => 'publish',
			);
			$coupons = get_posts( $args );
			$output = '<select name="send_coupons_id" required>';
			$output.= '<option value="">Select Coupon</option>';
			foreach ($coupons as $key => $value) { 
				$custom = get_post_custom($value->ID);
				$output.= '<option value="'.$value->ID.'">'.$value->post_title.' | Worth: '.$get_symbol.$custom['coupon_amount'][0].'</option>';
			} 
			$output.= '</select>';
			return $output;
		}
		public function coupon_pro_send_init() {
			if ( ! empty( $_GET['action'] ) && ( $_GET['action'] == 'sent_wp_coupon' ) && ! empty( $_GET['page'] ) && ( $_GET['page'] == 'coupon_pro_email_coupons' ) ) {
				$emails = $_POST['coupon_pro_email'];
				$coupon_type = $_POST['price_type'];
				$coupon_amount = $_POST['coupon_pro_amount'];
				$coupon_id = $_POST['send_coupons_id'];
				$message = stripslashes( $_POST['coupon_pro_message'] );
				if(!empty($coupon_id))
					$this->send_progos_sc_coupon( $emails, $coupon_id, $message );
				else
					$this->create_random_token_on_price( $emails, $coupon_type, $coupon_amount, $message );
			}
		}
		public function send_progos_sc_coupon( $emails, $coupon_id, $message ){
			$arrEmail = explode( ',', $emails );
			foreach ( $arrEmail as $email ) {
				$email = trim( $email );
				if ( count( $emails ) == 1 && ( ! $email || ! is_email( $email ) ) ) {
					$page_url = admin_url( 'admin.php?page=coupon_pro_email_coupons&email=invalid' );
				} elseif ( count( $emails ) == 1 && ( ! $coupon_id  ) ) {
					$page_url = admin_url( 'admin.php?page=coupon_pro_email_coupons&coupon_id=invalid' );
				} elseif ( is_email( $email ) && ($coupon_id ) ) {
					$coupon_title = $this->send_smart_coupon_by_email( $email, $coupon_id, $message );
					$page_url = admin_url( 'admin.php?page=coupon_pro_email_coupons&sent=valid' );
				}
			}
			wp_safe_redirect( $page_url );
		}
		public static function send_smart_coupon_by_email( $email, $coupon_id, $message ) {
			global $post;
			global  $woocommerce;
			$get_symbol =  get_woocommerce_currency_symbol();
			$obj_coupon = get_post($coupon_id);
			$arr_meta_data = get_post_custom($coupon_id); 
			$to = $email;
			$subject = 'Gift from '.get_bloginfo( 'name' ).'  worth of '.html_entity_decode($get_symbol).$arr_meta_data['coupon_amount'][0];
			$body = '<p>Coupon Code: '.$obj_coupon->post_title.'</p>';
			$body.= '<p><strong>Message</strong></p>';
			$body.= '<p>'.$message.'</p>';
			$headers = array('Content-Type: text/html; charset=UTF-8');
			wp_mail( $to, $subject, $body, $headers );
		}
		function create_random_token_on_price($emails, $coupon_type, $coupon_amount, $message ){
			$arrEmail = explode( ',', $emails );
			foreach ( $arrEmail as $email ) {
				$email = trim( $email );
				$page_url = NULL;
				if ( count( $emails ) == 1 && ( ! $email || ! is_email( $email ) ) ) {
					$page_url = admin_url( 'admin.php?page=coupon_pro_email_coupons&email=invalid' );
				} elseif ( count( $emails ) == 1 && ( ! $coupon_amount || ! is_numeric( $coupon_amount )  ) ) {
					$page_url = admin_url( 'admin.php?page=coupon_pro_email_coupons&coupon_amount=invalid' );
				} 
				if(!empty($page_url))
					wp_safe_redirect( $page_url );
			}
			$coupons_title = $this->RandomString();
			$coupon_data = array(
				'post_author'    => get_current_user_id(),
				'post_date'      => date( 'Y-m-d H:i:s'),
				'post_content'   => '', 
				'post_excerpt'   => '',
				'post_title'     => $coupons_title,
				'post_name'      => $coupons_title,
				'post_status'    => 'publish',
				'menu_order'     => 1,
				'post_type'      => 'shop_coupon',
			);
			$wp_error = true;
			$coupon_id = wp_insert_post( $coupon_data, $wp_error  );
			if ( is_wp_error( $coupon_id ) ) {
				echo 'yes error';
				return;
			}
			$coupon_meta = array(
				'discount_type' => trim($coupon_type),
				'coupon_amount' => $coupon_amount,
				'customer_email'  => $emails
			);
			foreach ( $coupon_meta as $meta_key => $meta_value ) {
				update_post_meta( $coupon_id, $meta_key, $meta_value);
			}
			$arrEmail = explode( ',', $emails );
			foreach ( $arrEmail as $email ) {
				$this->send_smart_coupon_by_email( $email, $coupon_id, $message ) ;
			}
			$page_url = admin_url( 'admin.php?page=coupon_pro_email_coupons&sent=valid' );
			wp_safe_redirect( $page_url );
		}
		public static function RandomString($length = 10) {
		    $characters = '0123456789abcdefghijklmnopqrstuvwxyz';
		    $charactersLength = strlen($characters);
		    $randomString = '';
		    for ($i = 0; $i < $length; $i++) {
		        $randomString .= $characters[rand(0, $charactersLength - 1)];
		    }
		    return $randomString;
		}
	}
}
new Coupon_Pro_Send_Email();