<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
if ( ! class_exists( 'Coupon_Pro_Settings_Helper' ) ) {
	/**
	 * Class settings of Coupons
	 */
	class Coupon_Pro_Settings_Helper {
		public static function tabs(){
			$tabs=apply_filters('smart_coupons_pro_settings_tabs',array(
					array(
						'name'=> __( 'Coupons', 'COUPON_PRO_TXT_DMN' ),
						'page'=> '',
					),
					array(
						'name'=> __( 'Email Coupon Credit', 'COUPON_PRO_TXT_DMN' ),
						'page'=> 'coupon_pro_email_coupons',
					),
					array(
						'name'=> __( 'Bulk Generate Coupons', 'COUPON_PRO_TXT_DMN' ),
						'page'=> 'coupon_pro_generate_bulk',
					),
					array(
						'name'=> __( 'Import Coupons', 'COUPON_PRO_TXT_DMN' ),
						'page'=> 'import_coupon_pro',
					),
					array(
						'name'=> __( 'Coupon Pro Settings', 'COUPON_PRO_TXT_DMN' ),
						'page'=> 'coupon_pro_setting',
					)
				));

			?>
			<div id="smart_coupons_tabs">
				<h2 class="nav-tab-wrapper">
					<?php
						$current=(isset($_GET['page']) && !empty($_GET['page']))? $_GET['page'] : '';
						foreach ($tabs as $key => $tab) {
							if(isset($tab['name']) && isset($tab['page'])){
								$url=empty($tab['page']) ? admin_url('edit.php?post_type=shop_coupon') : admin_url('admin.php?page='.$tab['page']);

								echo '<a href="'.esc_url($url).'" class="nav-tab '.(($current==$tab['page']) ? 'nav-tab-active' : '').'">'.esc_html($tab['name']).'</a>';
							}
						}				
					?>
				</h2>
			</div>
			<?php
		}
	}
}