<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
if ( ! class_exists( 'Coupon_Pro_Settings_Tab' ) ) {
	class Coupon_Pro_Settings_Tab {
		public function __construct() {
			add_action( 'admin_init', array( $this, 'register_settings' ) );			
			add_action( 'admin_menu', array( $this, 'coupon_pro_setting_menu') );
		}
		public function coupon_pro_setting_menu() {
			add_submenu_page(
							'woocommerce',
							'Smart Coupon Settings',
							'Smart Coupon Settings',
							'edit_pages', 'coupon_pro_setting',
							array($this , 'func_coupon_pro_setting' )
						);
		}
		public function register_settings() {
			register_setting('coupon-pro-setting-group', 'number_of_coupons_shown_text');
            register_setting('coupon-pro-setting-group', 'coupon_pro_email_subject_text');
            register_setting('coupon-pro-setting-group', 'coupon_pro_display_on_product_page_checkbox');
            register_setting('coupon-pro-setting-group', 'coupon_pro_display_on_customer_page_checkbox');
            register_setting('coupon-pro-setting-group', 'coupon_pro_display_on_cart_page');
            register_setting('coupon-pro-setting-group', 'coupon_pro_display_on_checkout_page');
            register_setting('coupon-pro-setting-group', 'coupon_pro_cart_checkout_page_title_text');
		}
		public function func_coupon_pro_setting() {
			?>
			<h2>
				<?php echo __( 'Coupons Pro', 'COUPON_PRO_TXT_DMN' ); ?>
				<a href="<?php echo trailingslashit( admin_url() ) . 'post-new.php?post_type=shop_coupon'; ?>" class="page-title-action"><?php echo __( 'Add Coupon', 'COUPON_PRO_TXT_DMN' ); ?></a>
			</h2>
			<?php 
				Coupon_Pro_Settings_Helper::tabs();
			?>
			<p class="description"><?php _e( 'Set up Coupon Pro. Use these options to configure/change Coupons Pro works.', 'COUPON_PRO_TXT_DMN' ); ?></p>
			<form method="post" action="options.php">
				<?php 
			 	settings_fields('coupon-pro-setting-group'); 
			 	do_settings_sections('coupon-pro-setting-group'); ?>
				<table class="form-table">
					<tbody>
						<tr>
							<td>
								<h2><?php _e('Coupons Pro Settings','COUPON_PRO_TXT_DMN'); ?></h2>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row" class="titledesc">
								<label for="number_of_coupons_shown_text"><?php _e('Number of coupons to show','COUPON_PRO_TXT_DMN'); ?></label>
								<span class="woocommerce-help-tip"></span>							
							</th>
							<td class="forminp forminp-number">
								<input name="number_of_coupons_shown_text" id="number_of_coupons_shown_text" type="number" style="width: 50%" value="<?php echo esc_attr(get_option('number_of_coupons_shown_text')); ?>" class="" placeholder=""> 							
							</td>
						</tr>
						<tr valign="top">
							<th scope="row" class="titledesc">
								<label for="coupon_pro_email_subject_text"><?php _e('Subject for Coupon emails','COUPON_PRO_TXT_DMN'); ?></label>
								<span class="woocommerce-help-tip"></span>							
							</th>
							<td class="forminp forminp-text">
								<input name="coupon_pro_email_subject_text" id="coupon_pro_email_subject_text" type="text" style="width: 50%" value="<?php echo esc_attr(get_option('coupon_pro_email_subject_text')); ?>" class="" placeholder=""> 							
							</td>
						</tr>
						<tr valign="top" class="">
							<th scope="row" class="titledesc"><?php _e('Displaying Coupons','COUPON_PRO_TXT_DMN'); ?></th>
							<td class="forminp forminp-checkbox">
								<fieldset>
									<legend class="screen-reader-text"><span><?php _e('Displaying Coupons','COUPON_PRO_TXT_DMN'); ?></span></legend>
									<label for="coupon_pro_display_on_product_page_checkbox">
										<input name="coupon_pro_display_on_product_page_checkbox" id="coupon_pro_display_on_product_page_checkbox" type="checkbox" class="" value="yes" <?php echo (get_option('coupon_pro_display_on_product_page_checkbox')=='yes') ? 'checked="checked"' : ''; ?>> 
										<?php _e("Include coupon details on product's page, for products that issue coupons","COUPON_PRO_TXT_DMN"); ?>					
									</label> 																
								</fieldset>
							</td>
						</tr>
						<tr valign="top" class="">
							<th scope="row" class="titledesc"></th>
							<td class="forminp forminp-checkbox">
								<fieldset>
									<label for="coupon_pro_display_on_cart_page">
										<input name="coupon_pro_display_on_cart_page" id="coupon_pro_display_on_cart_page" type="checkbox" class="" value="yes" <?php echo (get_option('coupon_pro_display_on_cart_page')=='yes') ? 'checked="checked"' : ''; ?>> 
										<?php _e('Show coupons available to customers on cart page','COUPON_PRO_TXT_DMN'); ?>						
									</label> 																
								</fieldset>
							</td>
						</tr>
						<tr valign="top" class="">
							<th scope="row" class="titledesc"></th>
							<td class="forminp forminp-checkbox">
								<fieldset>
									<label for="coupon_pro_display_on_checkout_page">
										<input name="coupon_pro_display_on_checkout_page" id="coupon_pro_display_on_checkout_page" type="checkbox" class="" value="yes" <?php echo (get_option('coupon_pro_display_on_checkout_page')=='yes') ? 'checked="checked"' : ''; ?>> 
										<?php _e('Show coupons available to customers on checkout page','COUPON_PRO_TXT_DMN'); ?>						
									</label> 																
								</fieldset>
							</td>
						</tr>
						<tr valign="top" class="">
							<th scope="row" class="titledesc"></th>
							<td class="forminp forminp-checkbox">
								<fieldset>
									<label for="coupon_pro_display_on_customer_page_checkbox">
										<input name="coupon_pro_display_on_customer_page_checkbox" id="coupon_pro_display_on_customer_page_checkbox" type="checkbox" class="" value="yes" <?php echo (get_option('coupon_pro_display_on_customer_page_checkbox')=='yes') ? 'checked="checked"' : ''; ?>> 
										<?php _e('Show coupons available to customers on their My Account  Coupons page','COUPON_PRO_TXT_DMN'); ?>						
									</label> 																
								</fieldset>
							</td>
						</tr>
						<tr>
							<td colspan="2">
								<h2><?php _e('Coupon Title(s)','COUPON_PRO_TXT_DMN'); ?></h2>
								<p><?php _e('Call it something else! Use these to quickly change coupon text labels through your store. Use translations for complete control.','COUPON_PRO_TXT_DMN'); ?></p>
							</td>
						</tr>
						<tr>
							<th scope="row" class="titledesc">
								<label for="coupon_pro_cart_checkout_page_title_text"><?php _e('On Cart/Checkout pages','COUPON_PRO_TXT_DMN'); ?></label>
								<span class="woocommerce-help-tip"></span>							
							</th>
							<td class="forminp forminp-text">
								<input name="coupon_pro_cart_checkout_page_title_text" id="coupon_pro_cart_checkout_page_title_text" type="text" style="width: 50%" value="<?php echo esc_attr(get_option('coupon_pro_cart_checkout_page_title_text')); ?>" class="" placeholder=""> 							
							</td>
						</tr>
					</tbody>
				</table>
				<p class="submit"><input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" /></p>
			</form>
			<?php 
		}
	}
}
new Coupon_Pro_Settings_Tab();