<?php
// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
if ( ! class_exists( 'PROGOS_SC_Coupon_Frontend_Usage' ) ) {
	class PROGOS_SC_Coupon_Frontend_Usage {
		public function __construct() {
			if(get_option('coupon_pro_display_on_cart_page')=='yes')
				add_action( 'woocommerce_after_cart_table', array($this, 'woocommerce_checkout_progos_sc_form' )); 
			if(get_option('coupon_pro_display_on_checkout_page')=='yes'){
				add_action('woocommerce_checkout_before_customer_details',array( $this, 'woocommerce_checkout_progos_sc_form_checkout' ));
				add_action('wp_ajax_smart_coupons_on_checkout',array( $this, 'woocommerce_checkout_progos_sc_form_ajax' ));
				add_action('wp_ajax_nopriv_smart_coupons_on_checkout',array( $this, 'woocommerce_checkout_progos_sc_form_ajax' ));
			}
			if(get_option('coupon_pro_display_on_product_page_checkbox')=='yes')
				add_action( 'woocommerce_after_add_to_cart_button', array( $this, 'show_attached_product_coupons' ) );
			
			add_action('wp_ajax_wsc_add_coupon_to_cart', array($this, 'add_coupon_to_cart'));
			add_action('wp_ajax_nopriv_wsc_add_coupon_to_cart', array($this, 'add_coupon_to_cart'));
			if(get_option('coupon_pro_display_on_customer_page_checkbox')=='yes'){
				add_action( 'init', array($this, 'add_coupons_page_endpoint' ));
				add_filter( 'query_vars',  array($this, 'coupons_page_query_vars'), 0 );
				add_filter( 'woocommerce_account_menu_items',array($this, 'coupons_page_link_my_account' ));
				add_action( 'woocommerce_account_smart-coupons_endpoint', array($this,'coupons_page_content' ));
			}
			add_action( 'wp_enqueue_scripts', array($this,'progos_smart_coupons_enqueue_scripts' ));
		}
		public function show_attached_product_coupons() {
			global $post;
			$get_symbol = get_woocommerce_currency_symbol();
			if ( empty( $post->ID ) ) {
				return;
			}
			$_product = $post->ID ;
			$coupons = get_posts( array(
			    'posts_per_page'   => -1,
			    'post_type'        => 'shop_coupon',
			    'post_status'      => 'publish',
			) );
			echo '<div class="clear"></div>';
			$is_coupon_has = false;
			$coupon_title = '<br><br><p>'.__("When you buy this product you will get following coupon(s)","COUPON_PRO_TXT_DMN").'</p>';
			$coupon_output = NULL;
			// loop through the coupons
			foreach ( $coupons as $coupon ) {
			    // get the product ids meta value
			    $product_ids = get_post_meta( $coupon->ID, 'product_ids', true );
			    $coupon_meta = get_post_meta( $coupon->ID );
			    $discount_type = $coupon_meta['discount_type'][0];
			    if($discount_type == 'percent') 
			    	$discount_sign = '%';
			    else
			    	$discount_sign = $get_symbol;			    	
			    // make sure something has been saved
			    if ( !empty( $product_ids ) ){
			        // convert from comma separated string to array
			        $id_list = explode( ',', $product_ids );
			        // loop over each ID
			        $coupon_output.= '<ul>';
			        foreach( $id_list as $product_id ){
			        	if($_product == $product_id){
			        		$coupon_output.= '<li>'.$coupon->post_title.' - '.$coupon_meta['coupon_amount'][0].$discount_sign.' Discount</li>';
			        		$is_coupon_has = true;
			        	}
			        }
			        $coupon_output.= '</ul>';
			    }
			}
			if($is_coupon_has) {
		    	echo $coupon_title;
		    	echo $coupon_output;
		    } 
		}
		public function woocommerce_checkout_progos_sc_form_checkout(){
			ob_start();
			echo '<div class="checkout-coupon-listing">';
			$this->woocommerce_checkout_progos_sc_form();
			echo '</div>';
			echo ob_get_clean();
		}
		public function woocommerce_checkout_progos_sc_form_ajax(){
			$this->woocommerce_checkout_progos_sc_form_checkout();
			die();
		}
		public function is_email_restricted($coupon_id){
			$emails=get_post_meta($coupon_id,'customer_email',true);
			if(is_user_logged_in() && !empty($emails) ){
	    		$current_user = wp_get_current_user();
			   	if(!in_array($current_user->user_email,$emails))
			        return true;
	    	}elseif (!is_user_logged_in() && !empty($emails)) {
	    		return true;
	    	}
	    	return false;
		}
		public function woocommerce_checkout_progos_sc_form() {
			wp_enqueue_script( 'coupon-pro-script');
			global $woocommerce;
			$product_ids = $product_cat_ids = array();
			$number_of_coupons = get_option('number_of_coupons_shown_text' );
			$checkout_cart_page_title = get_option('coupon_pro_cart_checkout_page_title_text' );
			$get_symbol = get_woocommerce_currency_symbol();
			$items = $woocommerce->cart->get_cart();
		    foreach($items as $item => $values) {
		    	$product_id = $values['data']->get_id();
				$product_ids[] = $product_id;
				$terms = get_the_terms( $product_id, 'product_cat' );
				if(!empty($terms)) {
					foreach ( $terms as $term ) {
	    				$product_cat_ids[] = $term->term_id;
	    			}
	    		}
		    } 
		    $html='';
		    $html.='<div class="coupon-listing">';		    	
		        $args = array(
				    'posts_per_page'   => -1,
				    'orderby'          => 'title',
				    'order'            => 'ASC',
				    'post_type'        => 'shop_coupon',
				    'post_status'      => 'publish',
				    'meta_query' => array(
				      array(
				         'key'     => 'smart_coupon_visible_on_cart',
				         'value'   => 'yes',
				         'compare' => 'IN'
				      )
				   )
				);

				$coupons = get_posts( $args );
				if(!empty($coupons)) {
					if(empty($checkout_cart_page_title))
						$html.='<h2>'.__("Available Coupons (click on a coupon to use it)","COUPON_PRO_TXT_DMN").'</h2>';
					else
						$html.='<h2>'.$checkout_cart_page_title.'</h2>';
				}
				$num =0;
				$number_of_coupons = (is_numeric($number_of_coupons) && $number_of_coupons > 0 ) ? $number_of_coupons : 5;
				$cphtml='';
				foreach ($coupons as $key => $value) { 
					$num++;
					if($num>$number_of_coupons)
						break;
					$custom = get_post_meta($value->ID);
					$coupons_applied = ( is_object( WC()->cart ) && is_callable( array( WC()->cart, 'get_applied_coupons' ) ) ) ? WC()->cart->get_applied_coupons() : array();
					if ( in_array( strtolower($value->post_title), $coupons_applied) ) { 
						continue;
					}
					
					//email restricted
			    	if($this->is_email_restricted($value->ID)){
			    		continue;
			    	}
					
					$coupon = new WC_Coupon($value->post_title);   
					if (!$coupon->is_valid()) {
		                continue;
		            }
				    $discounts = new WC_Discounts( WC()->cart );
				    $valid_response = $discounts->is_coupon_valid( $coupon );
				    if ( is_wp_error( $valid_response ) ) {
				        continue;
				    } 

					$expiry_date = isset($custom['expiry_date'][0]) ? $custom['expiry_date'][0] : '';
					if(empty($expiry_date)) {
						$expiry = __('Never Expires','COUPON_PRO_TXT_DMN');
					} else {
						$expiry = $expiry_date;
					}
					if(isset($custom['discount_type'][0]) && $custom['discount_type'][0] == 'percent')
						$coupon_worth = $custom['coupon_amount'][0].' %';
					else
						$coupon_worth = $get_symbol.$custom['coupon_amount'][0];
					
					$cphtml.='<div class="coupon-div">
						<div class="coupon-inner-div" id="'.$value->ID.'" style="cursor: pointer">
							<span class="coupon-title coupon-code">'.$value->post_title.'</span>
							<span class="coupon-amount">Coupon Worth: '.$coupon_worth.' </span>
							<span class="coupon-detail">'.$value->post_excerpt.'</span>
							<span class="coupon-date">'.$expiry.'</span>
							<input type="hidden" name="coupon-'.$value->ID.'" id="coupon-'.$value->ID.'" value="'.$value->post_title.'" />
						</div>
					</div>';
					
				 
				
				} 
			$html.=$cphtml;
			$html.='</div>';
			if($num>0 && !empty($cphtml))
			echo $html;
			else
			echo '';
		}

		public function add_coupon_to_cart() {
    		global $woocommerce;
			$coupon_code = $_POST['coupon-code'];
			$cart = ( is_object( WC() ) && isset( WC()->cart ) ) ? WC()->cart : null;
			if ( empty( $cart ) || WC()->cart->is_empty() ) {
				$this->hold_applied_coupon( $coupon_code );
			} else {
				if ( ! WC()->cart->has_discount( $coupon_code ) ) {
					WC()->cart->add_discount( trim( $coupon_code ) );
				}
			}
			die();
		}
		public function add_coupons_page_endpoint(){
			add_rewrite_endpoint( 'smart-coupons', EP_ROOT | EP_PAGES );
		}
		public function coupons_page_query_vars( $vars ) {
		    $vars[] = 'smart-coupons';
		    return $vars;
		}
		public function coupons_page_link_my_account($items){
			$items['smart-coupons'] = __('Coupon Codes','COUPON_PRO_TXT_DMN');
		    return $items;
		}
		public function coupons_page_content() {
			echo '<h3>'.__("Available Coupons","COUPON_PRO_TXT_DMN").'</h3>';
			global $woocommerce;
			$number_of_coupons = get_option('number_of_coupons_shown_text' );
			$number_of_coupons = (is_numeric($number_of_coupons) && $number_of_coupons > 0 ) ? $number_of_coupons : 5;
			$get_symbol = get_woocommerce_currency_symbol();
			$args = array(
			    'posts_per_page'   => -1,
			    'orderby'          => 'title',
			    'order'            => 'ASC',
			    'post_type'        => 'shop_coupon',
			    'post_status'      => 'publish',
			    'meta_query' => array(
				      array(
				         'key'     => 'smart_coupon_visible_on_my_account',
				         'value'   => 'yes',
				         'compare' => 'IN'
				      )
				   )
			);
			$coupons = get_posts( $args );
			$num =0;
			if(!empty($coupons)){
				echo '<div class="smart-coupon-list">';
				foreach ($coupons as $key => $value) { 
					$num++;
					$custom = get_post_custom($value->ID);
					//email restricted
			    	if($this->is_email_restricted($value->ID)){
			    		continue;
			    	}
			    	$coupons_applied = ( is_object( WC()->cart ) && is_callable( array( WC()->cart, 'get_applied_coupons' ) ) ) ? WC()->cart->get_applied_coupons() : array();
					if ( in_array( strtolower($value->post_title), $coupons_applied) ) { 
						continue;
					}
					$expiry_date = isset($custom['expiry_date'][0]) ? $custom['expiry_date'][0] : '';
					if(empty($expiry_date)) {
						$expiry = __('Never Expires','COUPON_PRO_TXT_DMN');
					} else {
						$expiry = $expiry_date;
						if(strtotime($expiry) < strtotime(date('Y-m-d')))
							continue;
					}
					if(isset($custom['discount_type'][0]) && $custom['discount_type'][0] == 'percent')
						$coupon_worth = $custom['coupon_amount'][0].' %';
					else
						$coupon_worth = $get_symbol.$custom['coupon_amount'][0]
					?>
					<div class="coupon-div">
						<div class="coupon-inner" id="<?php echo $value->ID; ?>" >
							<span class="coupon-title coupon-code"><?php echo $value->post_title; ?></span>
							<span class="coupon-amount">Coupon Worth: <?php echo $coupon_worth; ?> </span>
							<span class="coupon-detail"><?php echo $value->post_excerpt; ?></span>
							<span class="coupon-date"><?php echo $expiry; ?></span>
							<input type="hidden" name="coupon-<?php echo $value->ID; ?>" id="coupon-<?php echo $value->ID; ?>" value="<?php echo $value->post_title; ?>" />
						</div>
					</div>
					
				<?php 
					if($num>=$number_of_coupons){
						break;
					}
				}//endforeach
				echo '</div>';
			}// endif
		}
		public function progos_smart_coupons_enqueue_scripts() {
			global $woocommerce;
			wp_enqueue_style( 'coupon-pro-style', WC_COUPON_PRO_URL.'css/style.css', array() );
			wp_register_script( 'coupon-pro-script', WC_COUPON_PRO_URL.'js/script.js', array('jquery') );		
			$checkout=$enabled=false;
			if(is_checkout()){
				$checkout=true;
			}
			if(get_option('coupon_pro_display_on_checkout_page')=='yes'){
				$enabled=true;
			}
			wp_localize_script('coupon-pro-script','wc_coupons_pro', array(
				'ajaxurl'		=>	admin_url('admin-ajax.php'),
				'is_checkout'	=> $checkout,
				'is_checkout_enabled'=>$enabled
				));
		}
	}
	new PROGOS_SC_Coupon_Frontend_Usage();
}
